; ////////////////////////////////////////////////////////////////////////


      .386
      .model flat, stdcall
      option casemap :none   

;////////////////////////////////////////////////////////////////////////


      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

;////////////////////////////////////////////////////////////////////////

.data
        
        titre_err       db          'Erreur Erreur Erreur',0
        mess_err        db          'Pour obtenir un keyfile, selectionnez le keyfile_gen.exe '
				db	      'par l option "Parcourir" de l "Executer" du menu "Demarrer"',13,10
                        db          ' puis rajouter votre nom a la suite, separe du reste par un espace',0
        nom             db          'KwazyWeb.bit',0
        mess_err_ecr	db		'Erreur d ecriture du keyfile',0
	  c_tout_bon      db          'Keyfile cree avec succes',0   
        titre_ok        db          'Felicitation !',0
        fin_chemin      db          '.exe" ',0
        resultat        db     255   dup (0)
        cle            db    0A9h,0ABh,0A5h,10h,54h,3Fh,30h,55h,65h,16h,56h,0BEh,0F3h,0EAh,0E9h,50h,55h,0AFh
;////////////////////////////////////////////////////////////////////////

.data?
     	ptrNom		dd		?
      lg                dd          ?       
      lg_moins_un       dd          ?
      flag              db          ?
	joker		    	db		?
      fhandle           dd          ?
      bWritten          dd          ?
      quotient		db		?
	reste			db		?

;////////////////////////////////////////////////////////////////////////

.code

;------------------------------------------------------------------------------------------
; ANALYSE DE LA COMMANDE
;------------------------------------------------------------------------------------------
;Le but de cette premiere partie est de recuperer l'argument de notre generateur de keyfile,
;c'est a dire le nom de l'utilisateur.
;le resultat de la fonction GetCommandLine est une chaine de caractere contenant le chemin
;d'acces de l'excecutable puis son argument, le tout separe par un espace. Il faut donc 
;parcourir la chaine pour reperer la chaine '.exe "' puis mettre de cote ce qui suit.
;Ensuite on extrait et on teste la longueur du nom : si elle est nulle, ou a moins de deux
;caracteres ou en a plus de 16, on sort avec un message d'erreur.
;-------------------------------------------------------------------------------------------

debut:
        invoke      	GetCommandLine
        mov 		ptrNom, eax
        
extrait_nom:
        mov         esi, eax

boucle:
        xor         ecx, ecx
        mov         al, byte ptr [esi]
        cmp         al, fin_chemin[ecx]
        je          pt_trouve
        inc         esi
        jmp         boucle
        
pt_trouve:
        inc         esi
        inc         ecx
        mov         al, byte ptr [esi]
        cmp         al, fin_chemin[ecx]
        jne         boucle
        cmp         ecx, 5
        jne         pt_trouve
        inc         esi
        mov         al, byte ptr [esi]
        cmp         al, 0
        je          erreur_pas_darg
            
longueur_arg:
        mov         eax, esi       
        mov         ptrNom, eax
        invoke      lstrlen, ptrNom
        cmp         eax, 0
        je          erreur_pas_darg
             
;------------------------------------------------------------------------------------------
; ELABORATION DU CONTENU
;------------------------------------------------------------------------------------------
;
;--------------------------------------------------------------------------------------------

ecrit_longueur_nom:
        xor         ecx, ecx
        mov         resultat[ecx], al
        inc         ecx
        xor         ebx, ebx
        xor         edx, edx
        mov         esi, eax
        xor         eax, eax

recopie_nom_et_calcul_somme:
        mov         edi, ptrNom
        mov         bl, byte ptr [edi+edx]
        mov         resultat[ecx], bl
        add         eax,ebx
        inc         ecx
        inc         edx
        cmp         edx, esi         
        jne         recopie_nom_et_calcul_somme

        xor         edx, edx

xor_et_copie_cle:
        mov         bl, byte ptr [cle+edx]
        xor         bl, al 
        mov         resultat[ecx], bl
        inc         edx
        inc         ecx
        cmp         dl, 12h
        jne         xor_et_copie_cle


;-------------------------------------------------------------------------------------------
; CREATION ET ECRITURE DU KEYFILE
;-------------------------------------------------------------------------------------------
;On commence par concatener les trois chaines formees en une seule.
;Puis l'api createfile permet de creer le due-cm2.dat. Enfin, SetFilePointer et WriteFile
;copient la chaine obtenue dans le fichier.
;-------------------------------------------------------------------------------------------


cree_fichier:
        invoke      CreateFile, addr nom, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS,\
            FILE_ATTRIBUTE_NORMAL, 0
        mov         fhandle, eax
        cmp         eax, INVALID_HANDLE_VALUE
        je          err_ecriture
        
ecriture:
        invoke      SetFilePointer, fhandle, 0, 0, FILE_BEGIN        
        cmp         eax, 0FFFFFFFFh
        je          err_ecriture
        invoke      lstrlen, addr resultat
        invoke      WriteFile, fhandle, addr resultat, eax, addr bWritten,0
        cmp         eax, FALSE
        je          err_ecriture
        invoke      MessageBoxA, 0h, addr c_tout_bon, addr titre_ok, 0h

exit:
        invoke	ExitProcess, 0h
	

err_ecriture:      
	  invoke	MessageBoxA, 0h, addr mess_err_ecr, addr titre_err, 0h
        jmp       exit

erreur_pas_darg:
        invoke          MessageBoxA,0h, addr mess_err, addr titre_err,0h
        jmp             exit

end debut
;/////////////////////////////////////////////////////////////////////////